
__author__ = 'lmstack'
#coding=utf-8
import os
import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
import time, datetime
import dateutil.relativedelta
import traceback
from LIB.MIDDLE.OutlierDetection.VoltOutlier.V_1_0_0 import sta
from urllib import parse
import pymysql
import pdb
dbManager = DBManager.DBManager()
if __name__ == "__main__":
    
    # 时间设置
    now_time = datetime.datetime.now()
    pre_time = now_time + dateutil.relativedelta.relativedelta(days=-1)# 最近一周
    end_time=datetime.datetime.strftime(now_time,"%Y-%m-%d 00:00:00")
    start_time=datetime.datetime.strftime(pre_time,"%Y-%m-%d 00:00:00")
    
    history_run_flag = False # 历史数据运行标志
    
    
    # 更新sn列表
    host='rm-bp10j10qy42bzy0q7.mysql.rds.aliyuncs.com'
    port=3306
    db='qixiang_oss'
    user='qixiang_oss'
    password='Qixiang2021'
    conn = pymysql.connect(host=host, port=port, user=user, password=password, database=db)
    cursor = conn.cursor()
    cursor.execute("select sn, imei, add_time from app_device")
    res = cursor.fetchall()
    df_sn = pd.DataFrame(res, columns=['sn', 'imei', 'add_time'])
    df_sn = df_sn.reset_index(drop=True)
    conn.close();
    
    # 数据库配置
    host = 'rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port = 3306
    user = 'qx_cas'
    password = parse.quote_plus('Qx@123456')
    database = 'qx_cas'

    db_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, password, host, port, database
        ))
    DbSession = sessionmaker(bind=db_engine)
    
    # 运行历史数据配置
    
    df_first_data_time = pd.read_sql("select * from bat_first_data_time", db_engine)

    
    # 日志配置
    now_str = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()).replace(":","_")
    log_path = 'log/' + now_str
    if not os.path.exists(log_path):
        os.makedirs(log_path)
    log = Log.Mylog(log_name='voltoutlier', log_level = 'info')
    log.set_file_hl(file_name='{}/info.log'.format(log_path), log_level='info', size=1024* 1024 * 100)
    log.set_file_hl(file_name='{}/error.log'.format(log_path), log_level='error', size=1024* 1024 * 100)
    logger = log.get_logger()

    logger.info("pid is {}".format(os.getpid()))
    


    # 算法参数
    host='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port=3306
    db='qx_cas'
    user='qx_read'
    password='Qx@123456'
    tablename='cellStateEstimation_soh'

    for i in range(0, len(df_sn)):
        try:
            sn = df_sn.loc[i, 'sn']
            
            logger.info("pid-{} SN: {} START!".format(os.getpid(), sn))
            
            
            # 处理运行历史数据
            if (history_run_flag):
                this_sn = df_first_data_time[df_first_data_time['sn']==sn]
                if (len(this_sn) == 0):
                    start_time = pd.to_datetime(str(df_sn.loc[df_sn[df_sn['sn']==sn].index, 'add_time'].values[0])).strftime("%Y-%m-%d 00:00:00")
                else:
                    first_data_time = df_first_data_time.loc[df_first_data_time[df_first_data_time['sn']==sn].index, 'first_data_time'].values[0]
                    if pd.isnull(first_data_time):
                        start_time = "2018-01-01 00:00:00"
                    else:
                        start_time = pd.to_datetime(str(df_first_data_time.loc[df_first_data_time[df_first_data_time['sn']==sn].index, 'first_data_time'].values[0])).strftime("%Y-%m-%d 00:00:00")

            df_data = dbManager.get_data(sn=sn, start_time=start_time, end_time=end_time, data_groups=['bms'])
            df_bms = df_data['bms']
            volt_column = [x for x in df_bms.columns if '单体电压' in x]
            columns = ['时间戳']
            columns.extend(volt_column)
            
            df_ori = df_bms[columns]
            df_ori.rename(columns = {'时间戳':'time'}, inplace=True)
            df = df_ori.drop_duplicates(subset=['time']).reset_index(drop=True) # 删除时间相同的数据
            df_result_1,time_list_1 = sta.cal_voltdiff_uniform(df,volt_column, window=50, step=10, window2=5, step2=3)
            df_result_2,time_list_2 = sta.cal_volt_uniform(df,volt_column, window=50, step=10)

            df_result_1['time'] = time_list_1
            df_result_2['time'] = time_list_2
            
            df_all_result = sta.instorage(sn, df_result_1, df_result_2)

            if not df_all_result.empty:
                df_all_result.to_sql("outlierdetection_volt",con=db_engine, if_exists="append",index=False)
            logger.info("pid-{} SN: {} DONE!".format(os.getpid(), sn))
        except:
            logger.error(traceback.format_exc)
            logger.error(u"{} ：{},{} 任务运行错误\n".format(sn,start_time,end_time), exc_info=True)

